/* MoarNES source - CPU.c

   This open-source software is (c)2010-2011 Mike Chambers, and is released
   under the terms of the GNU GPL v2 license.

   This code determines which cheat codes were entered via the Game Genie ROM.
*/

#include <stdio.h>
#include "common.h"
#include "stdint.h"
#include "rom.h"

extern struct cheat_s cheat[3];
extern uint8_t gamegenie;

extern bool loadROM(uint8_t *filename);

void geniewrite(uint16_t addr, uint8_t value) {
	uint8_t cnum;

	cnum = ((addr&0xF)-1)>>2;
	switch (addr) {
		case 0x8000:
			if (value == 0) {
				gamegenie = 2;
				loadROM(NULL);
			} else {
				if (value & 2) cheat[0].docompare = 1;
				if (value & 4) cheat[1].docompare = 1;
				if (value & 8) cheat[2].docompare = 1;
				if (value & 16) cheat[0].valid = 0; else cheat[0].valid = 1;
				if (value & 32) cheat[1].valid = 0; else cheat[1].valid = 1;
				if (value & 64) cheat[2].valid = 0; else cheat[2].valid = 1;
			}
			break;

		case 0x8001:
			cheat[0].addr = ((uint16_t)value << 8) | (cheat[0].addr & 0x00FF);
			break;
		case 0x8002:
			cheat[0].addr = (uint16_t)value | (cheat[0].addr & 0xFF00);
			break;
		case 0x8003:
			cheat[0].compare = value;
			break;
		case 0x8004:
			cheat[0].replace = value;
			break;

		case 0x8005:
			cheat[1].addr = ((uint16_t)value << 8) | (cheat[1].addr & 0x00FF);
			break;
		case 0x8006:
			cheat[1].addr = (uint16_t)value | (cheat[1].addr & 0xFF00);
			break;
		case 0x8007:
			cheat[1].compare = value;
			break;
		case 0x8008:
			cheat[1].replace = value;
			break;

		case 0x8009:
			cheat[2].addr = ((uint16_t)value << 8) | (cheat[2].addr & 0x00FF);
			break;
		case 0x800A:
			cheat[2].addr = (uint16_t)value | (cheat[2].addr & 0xFF00);
			break;
		case 0x800B:
			cheat[2].compare = value;
			break;
		case 0x800C:
			cheat[2].replace = value;
			break;
	}
}
